;by Will West
;this is free and therefore I am not responsible for any
;damages caused by use of these routines
#define Link_Off $0C3
#define Port 0
#define Link_On $0C0



INTRPT_MASK   .EQU   %00001010

;==========================================================
;Background Sound
;==========================================================
StartSound:
    di             ;disables interrupts
    ld (location+6),ix
    EXX
    ld hl,(location+6)     ;loads the sound data
    ld e,(hl)      ;loads e with hl
    inc hl         ;increases hl
    ld d,(hl)      ;loads d with hl
    inc hl         ;increases hl
    ld b,128       ;stores b as 128         
    EXX
    LD     HL,Sound_interupt
    LD     ($993F), HL
    LD     ($997F), HL
    LD     ($99BF), HL
    LD     ($99FF), HL
    LD     A, $99
    LD     I, A

    LD     A, INTRPT_MASK   
    OUT    (3), A

    IM     2               ; Switch to Mode 2
    EI                     ; Activate interrupts

Sound_interupt:
    EX     AF, AF'
    EXX
    ld a,(Tempo)
    ld c,a         ;stores c as Tempo 19 is default
    jr Loop
Loop:
    dec c          ;decreases c
    nop            ;nothing happens here (timing)
    nop            ;nothing happens here (timing)
    nop            ;nothing happens here (timing)
    jr nz,Loop     ;loops until c is 0
    rrc b          ;rotate rigth and carry b
    jr nc,Play     ;goes, if no carry, to Play
    inc hl         ;increases hl
    dec de         ;decreases de
    ld a,d         ;loads a with value from d
    or e           ;compares a with e using Boolean 'or'
    jr z,StartSound;if true, goes to Done
Play:
    ld a,(hl)      ;loads a with hl
    and b          ;compares with b using Boolean 'and'
    jr z,Play1     ;if true, go to Play1
    ld a,Link_On   ;load a with the 'Link_Off' value
    out (Port),a   ;turn off the link port
    EX     AF, AF'
    EXX
    RET
Play1:
    ld a,Link_Off  ;load a with the 'Link_On' value
    out (Port),a   ;turn on the link port
    EX     AF, AF'
    EXX
    RET
;==========================================================
;Sound Effect
;==========================================================    
SoundEffect:
    di             ;disables interrupts
    ld (location+6),ix
    EXX
    ld (location),bc
    ld (location+2),de
    ld (location+4),hl
    ld hl,(location+6)       ;loads the sound data
    ld e,(hl)      ;loads e with hl
    inc hl         ;increases hl
    ld d,(hl)      ;loads d with hl
    inc hl         ;increases hl
    ld b,128       ;stores b as 128         
    EXX
    LD     HL,Sound_interupt2
    LD     ($993F), HL
    LD     ($997F), HL
    LD     ($99BF), HL
    LD     ($99FF), HL
    LD     A, $99
    LD     I, A

    LD     A, INTRPT_MASK   
    OUT    (3), A

    IM     2               ; Switch to Mode 2
    EI                     ; Activate interrupts

Sound_interupt2:
    EX     AF, AF'
    EXX
    ld a,(Tempo)
    ld c,a         ;stores c as Tempo 19 is default
    jr Loop2
Loop2:
    dec c          ;decreases c
    nop            ;nothing happens here (timing)
    nop            ;nothing happens here (timing)
    nop            ;nothing happens here (timing)
    jr nz,Loop2    ;loops until c is 0
    rrc b          ;rotate rigth and carry b
    jr nc,Play2    ;goes, if no carry, to Play
    inc hl         ;increases hl
    dec de         ;decreases de
    ld a,d         ;loads a with value from d
    or e           ;compares a with e using Boolean 'or'
    jr z,SoundEffectOff  ;if true, goes to Done
Play2:
    ld a,(hl)      ;loads a with hl
    and b          ;compares with b using Boolean 'and'
    jr z,Play12    ;if true, go to Play1
    ld a,Link_On   ;load a with the 'Link_Off' value
    out (Port),a   ;turn off the link port
    EX     AF, AF'
    EXX
    RET
Play12:
    ld a,Link_Off  ;load a with the 'Link_On' value
    out (Port),a   ;turn on the link port
    EX     AF, AF'
    EXX   
    RET
    
    
SoundOff:
    IM  1
    EI

SoundEffectOff:    
    ld bc,(location)
    ld de,(location+2)
    ld hl,(location+4)
    EX  AF,AF'
    EXX 
    LD     HL,Sound_interupt
    LD     ($993F), HL
    LD     ($997F), HL
    LD     ($99BF), HL
    LD     ($99FF), HL
    LD     A, $99
    LD     I, A

    LD     A, INTRPT_MASK   
    OUT    (3), A

    IM     2               ; Switch to Mode 2
    EI                     ; Activate interrupts

    
SetTempo:
    ld  a,(Tempo)
    ld  a,b
    ld  (Tempo),a
    
    


End_:
    RET
    
Tempo:
    .db 19
    
    
   


Location:
    .dw 0       ;bc
    .dw 0       ;de
    .dw 0       ;hl
    .dw 0       ;ix

.end